// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
package model;

import javafx.io.http.HttpRequest;
import javafx.lang.FX;
import javafx.stage.AppletStageExtension;
import javafx.util.Math;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;
import <<at>>.jku.ssw.worms.score.crypto.Cryptor;

public class Score {

    public-init var name: String;
    public-init var score: Integer;
}
def SERVER_URL = "http://ml-test-001.appspot.com/"; // "http://localhost:8080/";

public function getScores(callback: function(Score[])): Void {
    def reqest: HttpRequest = HttpRequest {
                location: "{SERVER_URL}get.do"
                onInput: function(is: InputStream) {
                    var scores: Score[];
                    try {
                        var br = new BufferedReader(new InputStreamReader(is));
                        var line: String;
                        while ((line = br.readLine()) != null) {
                            def scoreArr = line.split(":");
                            def name = scoreArr[0];
                            def score = Integer.parseInt(scoreArr[1]);
                            insert Score { name: name, score: score } into scores;
                        }
                        callback(scores);
                    } finally {
                        is.close();
                    }
                }
            }
    reqest.start();
}

public function setScore(score: Score, callback: function(Score[])): Void {
    def salt = Math.random();
    def scoreEnc = Cryptor.encrypt("{score.score}:{salt}:{score.name}");
    def url = "{SERVER_URL}score.do?score={scoreEnc}";

    if (__PROFILE__ == "browser") {
        setScoreFromApplet(url);
    } else {
        setScoreFromDesktop(url, callback);
    }
}

function setScoreFromDesktop(url: String, callback: function(Score[])): Void {
    def request: HttpRequest = HttpRequest {
                location: url
                onDoneConnect: if (callback != null) function() {
                        getScores(callback);
                    } else null
            }
    request.start();
}

function setScoreFromApplet(url: String): Void {
    AppletStageExtension.showDocument(url, "wormscore");
}
