// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
package model;

import java.lang.IllegalArgumentException;

public class Worm {

    public-init var startX: Integer;
    public-init var startY: Integer;
    public var direction: Direction = Direction.UP;
    public-read var segments: Segment[] = [];
    var segmentsToGrow: Integer on replace {
                if (segmentsToGrow < 0) { throw new IllegalArgumentException(); }
            };

    public function move(): Void {
        advanceHead();
        advanceTail();
    }

    public function grow(bySegments: Integer): Void {
        segmentsToGrow += bySegments;
    }

    public function reset() {
        delete  segments;
        insert Segment { x: startX, y: startY } into segments;
    }

    function advanceTail(): Void {
        if (not hasSegments()) {
            return;
        }
        if (segmentsToGrow == 0) {
            delete  segments[sizeof segments - 1];
        } else {
            segmentsToGrow--;
        }
    }

    function advanceHead(): Void {
        if (not hasSegments()) {
            return;
        }
        var curHead: Segment = segments[0];
        var newHead: Segment;

        if (direction == Direction.UP) {
            newHead = Segment { x: curHead.x; y: curHead.y - 1; };
        } else if (direction == Direction.DOWN) {
            newHead = Segment { x: curHead.x; y: curHead.y + 1; };
        } else if (direction == Direction.LEFT) {
            newHead = Segment { x: curHead.x - 1; y: curHead.y; };
        } else if (direction == Direction.RIGHT) {
            newHead = Segment { x: curHead.x + 1; y: curHead.y; };
        } else {
            throw new IllegalArgumentException("Unknown value: {direction}");
        }

        insert newHead before segments[0];
    }

    function hasSegments(): Boolean {
        return sizeof segments > 0;
    }

    init {
        reset();
    }

}
